#!/bin/sh
GLDIR="/glftpd"
ME=`whoami`
VERSION="0.84"

if [ ! "$ME" = "root" ]; then
  echo "Oops! You need to be root to run this script."
  exit 1
else
  echo "This will install SpaceOnDevice v$VERSION, a set of scripts for"
  echo "glftpd admins."
  echo ""
  echo "The installer will ask a few questions. If you want to abort,"
  echo "press CTRL-C. Pressing <ENTER> will assume the default"
  echo "setting marked within [brackets]."
  echo ""
  echo -n "Enter you glftpd directory [$GLDIR]> "; read input
  if [ ! "$input" = "" ]; then
    GLDIR=$input
  fi
  PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$GLDIR/bin"
  if [ ! -e /bin/bash ]; then
    echo "bash cannot be found in your /bin -directory."
    echo "I will create a symlink to it."
    BASH=`which bash`
    if [ ! "$BASH" = "" ]; then
      ln -s $BASH /bin/bash
      echo "done"
    else
      echo "Oops! Cannot find bash anywhere! Cannot continue!"
      exit 3;
    fi
  fi
  echo '#!'"`which bash`" > sod_cron
  echo "`which gzip` -q -9 $GLDIR/ftp-data/logs/sod.log" >> sod_cron
  echo "echo \"\`date\`: Logfile turned over. \" > $GLDIR/ftp-data/logs/sod.log" >> sod_cron
  INSTALL_DIR="$GLDIR/bin"
  echo "copying files into $INSTALL_DIR"
  cp -fv sod_exe $INSTALL_DIR
  cp -fv spaceondevice $INSTALL_DIR
  cp -fv freespace $INSTALL_DIR
  cp -fv makearchive $INSTALL_DIR
  cp -fv touchit $INSTALL_DIR
  cp -fv sod_cron $INSTALL_DIR
  echo "compiling mtime into $INSTALL_DIR"
  gcc -o "$INSTALL_DIR/mtime" mtime.c
  echo "marking files as executables"
  chmod +x $INSTALL_DIR/sod_exe
  chmod +x $INSTALL_DIR/spaceondevice
  chmod +x $INSTALL_DIR/freespace
  chmod +x $INSTALL_DIR/makearchive
  chmod +x $INSTALL_DIR/touchit
  chmod +x $INSTALL_DIR/mtime
  chmod +x $INSTALL_DIR/sod_cron
  echo "Done."
  echo ""
  echo "You should now edit the config-file to match your setup."
  echo -n "Edit config with 'vi' now? (y/n)[y]> "; read input
  if [ "$input" = "n" ]; then
    EDIT="n"
  elif [ "$input" = "N" ]; then
    EDIT="n"
  elif [ "$input" = "NO" ]; then
    EDIT="n"
  elif [ "$input" = "no" ]; then
    EDIT="n"
  elif [ "$input" = "No" ]; then
    EDIT="n"
  else
    EDIT="y"
  fi
  if [ ! "$EDIT" = "n" ]; then
    vi $INSTALL_DIR/spaceondevice
  fi
  echo ""
  echo "To make the script work as it should, add the following in crontab:"
  echo ""
  echo "1 * * * *  $INSTALL_DIR/spaceondevice >> $GLDIR/ftp-data/logs/sod.log"
  echo "30 3 * * 3,6 $INSTALL_DIR/sod_cron > /dev/null 2>&1"
  echo ""
  echo "People who rather have next day's dir be made before midnight than 1"
  echo "minute past will be happy to know that the script add 2 minutes to the"
  echo "date, so the following will also work:"
  echo ""
  echo "59 * * * *  $INSTALL_DIR/spaceondevice >> $GLDIR/ftp-data/logs/sod.log"
  echo "30 3 * * 3,6 $INSTALL_DIR/sod_cron > /dev/null 2>&1"
  echo ""
  echo -n "Edit crontab now? (y/n) [y]> "; read input
  if [ "$input" = "n" ]; then
    EDIT="n"
  elif [ "$input" = "N" ]; then
    EDIT="n"
  elif [ "$input" = "NO" ]; then
    EDIT="n"
  elif [ "$input" = "no" ]; then
    EDIT="n"
  elif [ "$input" = "No" ]; then
    EDIT="n"
  else
    EDIT="y"
  fi
  if [ ! "$EDIT" = "n" ]; then
    crontab -e
  fi
  echo ""
  echo "All done! Enjoy!"
  echo ""
  echo "-psxc"
  echo ""
  exit 0
fi
